Subject: Re: [RFC][PATCH] rcu: Use typeof(p) instead of typeof(*p) *

From: Mathieu Desnoyers <[email-masked]>
Date: Tue, 5 Oct 2021 15:49:58 -0400 (EDT)

----- On Oct 5, 2021, at 3:40 PM, rostedt [email-masked] wrote:

> On Tue, 5 Oct 2021 21:06:36 +0200 (CEST)
> Jan Engelhardt <[email-masked]> wrote:
> 
>> On Tuesday 2021-10-05 20:40, Steven Rostedt wrote:
>> >>   
>> >> >>>> typeof(*p) *________p1 = (typeof(*p) *__force)READ_ONCE(p);
>> >> 
>> >> #define static_cast(type, expr) ((struct { type x; }){(expr)}.x)
>> >> typeof(p) p1 = (typeof(p) __force)static_cast(void *, READ_ONCE(p));
>> >> 
>> >> Let the name not fool you; it's absolutely _not_ the same as C++'s
>> >> static_cast, but still: it does emit a warning when you do pass an
>> >> integer, which is better than no warning at all in that case.
>> >> 
>> >>  *flies away*
>> >
>> >Are you suggesting I should continue this exercise ;-)
>> 
>> “After all, why not?”
>> 
>> typeof(p) p1 = (typeof(p) __force)READ_ONCE(p) +
>>                BUILD_BUG_ON_EXPR(__builtin_classify_type(p) != 5);
> 
> I may try it, because exposing the structure I want to hide, is pulling out
> a lot of other crap with it :-p

I like the static_cast() approach above. It is neat way to validate that the
argument is a pointer without need to dereference the pointer.

I would also be open to consider this trick for liburcu's userspace API.

About the other proposed solution based on __builtin_classify_type, I am
reluctant to use something designed specifically for varargs in a context
where they are not used.

Thanks,

Mathieu

-- 
Mathieu Desnoyers
EfficiOS Inc.
http://www.efficios.com